unit Unit1;

interface

uses
  Windows, Classes, Graphics, Controls, Forms, StdCtrls, Graph3, Buttons,
  XPMan, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button5: TButton;
    ScrollBar1: TScrollBar;
    Button6: TButton;
    Button1: TSpeedButton;
    Button2: TSpeedButton;
    Button3: TSpeedButton;
    Button4: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    XPManifest1: TXPManifest;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ColorBox1: TColorBox;
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure Button6Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure ColorBox1Change(Sender: TObject);
  private
    FGraph: TGraph;
  end;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  FGraph := TGraph.Create(Self);
  FGraph.SetBounds(10, 150, 500, 500);
  FGraph.Anchors := [akLeft, akTop, akRight, akBottom];
  FGraph.Color := clWhite;
  FGraph.Font.Color := clGray;
  FGraph.AxisColor := clSilver;
  FGraph.AddEquation(0, 0, 0, -3, clBlue, 'f');
  FGraph.AddEquation(0, 0, 1, 1, clRed, 'g');
  FGraph.AddEquation(0, 1, 1, -2, clLime, 'h');
  FGraph.AddEquation(1, -3, 2, -1, clPurple, 'k');
  FGraph.Parent := Self;
  for I := 0 to FGraph.EquationCount - 1 do
    Memo1.Lines.Add(FGraph.Equations[I].Formula(True));
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  with FGraph.Equations[TComponent(Sender).Tag] do
    Visible := not Visible;
end;

procedure TForm1.ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  FGraph.Equations[1].A := ScrollPos;
  Memo1.Lines[2] := FGraph.Equations[1].Formula(True);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  FGraph.AnimateTangents(2);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  FGraph.AnimateTangents(3);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if SpeedButton1.Down then
    FGraph.PaintOptions := FGraph.PaintOptions + [poScale]
  else
    FGraph.PaintOptions := FGraph.PaintOptions - [poScale];
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  if SpeedButton2.Down then
    FGraph.PaintOptions := FGraph.PaintOptions + [poFormula]
  else
    FGraph.PaintOptions := FGraph.PaintOptions - [poFormula];
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  if SpeedButton3.Down then
    FGraph.PaintOptions := FGraph.PaintOptions + [poDerivative1]
  else
    FGraph.PaintOptions := FGraph.PaintOptions - [poDerivative1];
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  if SpeedButton4.Down then
    FGraph.PaintOptions := FGraph.PaintOptions + [poZeroPoints]
  else
    FGraph.PaintOptions := FGraph.PaintOptions - [poZeroPoints];
end;

procedure TForm1.ColorBox1Change(Sender: TObject);
begin
  FGraph.Equations[0].Color := ColorBox1.Selected;
end;

end.
